#include <cstdio>

#include <dlfcn.h>
#include "thing.hh"
#include "dynlib.hh"

template<typename T>
static void getsym(T &p, void *handle, const char *const name)
{
	const char *dlerr;
	
	p = (T)dlsym(handle, name);
	if((dlerr = dlerror()))
	{
		std::fprintf(stderr, "%s\n", dlerr);
		return;
	}
	return;
}

int main(void)
{
	void *dlp = dlopen("libmama.so", RTLD_LAZY);
	if(!dlp)
	{
		std::fprintf(stderr, "Groaa! %s\n", dlerror());
		return -1;
	}
	
	struct dyncontent *contents;
	getsym(contents, dlp, "contents");
	
	for(unsigned a=0; contents[a].name; ++a)
	{
		std::printf("Getting '%s'\n", contents[a].name);
		
		switch(contents[a].basetype)
		{
			case BASETYPE_THING:
			{
				Thing *t = (Thing *) contents[a].maker();
				t->Wave();
				delete t;
				break;
			}
			default:
				std::printf("Oops! Unknown type?? %d\n", contents[a].basetype);
		}
	}
	
	dlclose(dlp);

	return 0;
}
